SGU101题解

欧拉路径的解法见我的另一篇文章:http://www.cnblogs.com/shao0099876/p/7366852.html

算法细节如下:

读入边的数据,用sticktype存储,用vis标记解决输出时候的重复问题

对于每一条边看做无向边,对于每一个顶点,其相邻顶点用next数组标记,因为顶点数少,且出现重边情况,所以用计数方法存储,amount存储顶点的度,vis标记用于判断图的连通性

判断特殊情况后,深搜遍历边,对于当前搜索到的顶点,枚举每一条与之相邻的边,将该边删除,并搜索该边的另一个顶点,如果相邻的边都被遍历过,将该顶点放入队列并回溯。

搜索完成后,先判断一下图的连通性。生成的队列为欧拉路径的逆序,根据序列找到相应的边,判断方向,输出即可

  1 #include<iostream>
  2 #include<algorithm>
  3 using namespace std;
  4 struct sticktype
  5 {
  6     int l;
  7     int r;
  8     bool vis;
  9 }stick[101];
 10 struct pointtype
 11 {
 12     int amount;
 13     int next[7];
 14     bool vis;
 15 }point[7];
 16 int tail=0;
 17 int queue[201];
 18 void dfs(int p);
 19 int main()
 20 {
 21     int n;
 22     cin>>n;
 23     for(int i=0;i<=6;i++)
 24     {
 25         point[i].amount=0;
 26         for(int j=0;j<=6;j++)
 27         {
 28             point[i].next[j]=0;
 29         }
 30     }
 31     for(int i=1;i<=n;i++)
 32     {
 33         cin>>stick[i].l>>stick[i].r;
 34         stick[i].vis=false;
 35         point[stick[i].l].vis=false;
 36         point[stick[i].r].vis=false;
 37         point[stick[i].l].amount++;
 38         point[stick[i].l].next[stick[i].r]+=1;
 39         point[stick[i].r].amount++;
 40         point[stick[i].r].next[stick[i].l]+=1;
 41     }
 42     int m=0;
 43     int res=0;
 44     for(int i=0;i<=6;i++)
 45     {
 46         if(point[i].amount!=0)
 47         {
 48             m++;
 49             if(point[i].amount%2!=0)
 50             {
 51                 res++;
 52             }
 53         }
 54     }
 55     if(res!=0&&res!=2)
 56     {
 57         cout<<"No solution";
 58         return 0;
 59     }
 60     int begin;
 61     if(res==0)
 62     {
 63         for(int i=0;i<=6;i++)
 64         {
 65             if(point[i].amount!=0)
 66             {
 67                 begin=i;
 68                 break;
 69             }
 70         }
 71     }
 72     else
 73     {
 74         for(int i=0;i<=6;i++)
 75         {
 76             if(point[i].amount%2!=0)
 77             {
 78                 begin=i;
 79                 break;
 80             }
 81         }
 82     }
 83     dfs(begin);
 84     for(int i=0;i<=6;i++)
 85     {
 86         if(!point[i].vis&&point[i].amount!=0)
 87         {
 88             cout<<"No solution";
 89             return 0;
 90         }
 91     }
 92     for(int i=tail;i>=2;i--)
 93     {
 94         for(int j=1;j<=n;j++)
 95         {
 96             if(!stick[j].vis)
 97             {
 98                 if(stick[j].l==queue[i-1]&&stick[j].r==queue[i])
 99                 {
100                     stick[j].vis=true;
101                     cout<<j<<" -"<<endl;
102                     break;
103                 }
104                 if(stick[j].r==queue[i-1]&&stick[j].l==queue[i])
105                 {
106                     stick[j].vis=true;
107                     cout<<j<<" +"<<endl;
108                     break;
109                 }
110             }
111         }
112     }
113     return 0;
114 }
115 bool check(int p)
116 {
117     for(int i=0;i<=6;i++)
118     {
119         if(point[p].next[i])
120         {
121             return false;
122         }
123     }
124     return true;
125 }
126 void dfs(int p)
127 {
128     point[p].vis=true;
129     for(int i=0;i<=6;i++)
130     {
131         while(point[p].next[i])
132         {
133             point[p].next[i]--;
134             int next_point=i;
135             point[next_point].next[p]--;
136             dfs(next_point);
137         }
138     }
139     if(check(p))
140     {
141         tail++;
142         queue[tail]=p;
143     }
144     return;
145 }
时间: 2024-10-05 04:09:42

SGU101题解的相关文章

洛谷 P1079 Vigen&#232;re 密码 题解

此文为博主原创题解,转载时请通知博主,并把原文链接放在正文醒目位置. 题目链接:https://www.luogu.org/problem/show?pid=1079 题目描述 16 世纪法国外交家 Blaise de Vigenère 设计了一种多表密码加密算法――Vigenère 密 码.Vigenère 密码的加密解密算法简单易用,且破译难度比较高,曾在美国南北战争中为 南军所广泛使用. 在密码学中,我们称需要加密的信息为明文,用 M 表示:称加密后的信息为密文,用 C 表示:而密钥是一种

8.8联考题解

今天的T1让我怀疑我是不是在做奥赛题--这考的是什么知识点啊这个,会不会用绝对值函数? Evensgn 的债务 时间限制: 1 Sec  内存限制: 128 MB 题目描述 Evensgn 有一群好朋友,他们经常互相借钱.假如说有三个好朋友A,B,C.A 欠 B 20 元,B 欠 C 20 元,总债务规模为 20+20=40 元.Evensgn 是个追求简约的人,他觉得这样的债务太繁杂了.他认为,上面的债务可以完全等价为 A 欠C20 元,B 既不欠别人,别人也不欠他.这样总债务规模就压缩到了 

POJ 2533 - Longest Ordered Subsequence(最长上升子序列) 题解

此文为博主原创题解,转载时请通知博主,并把原文链接放在正文醒目位置. 题目链接:http://poj.org/problem?id=2533 Description A numeric sequence of ai is ordered if a1 < a2 < ... < aN. Let the subsequence of the given numeric sequence (a1, a2, ..., aN) be any sequence (ai1, ai2, ..., aiK)

(leetcode题解)Pascal&#39;s Triangle

Pascal's Triangle  Given numRows, generate the first numRows of Pascal's triangle. For example, given numRows = 5,Return [ [1], [1,1], [1,2,1], [1,3,3,1], [1,4,6,4,1] ] 题意实现一个杨辉三角. 这道题只要注意了边界条件应该很好实现出来,C++实现如下 vector<vector<int>> generate(int

2017ZZUACM省赛选拔试题部分题解----谨以纪念我这卡线滚粗的美好经历

写在前面: 其实心里有些小小的不爽又有点小小的舒畅,为啥捏?不爽当然是因为没被选拔上啦,舒畅捏则是因为没被选拔上反而让自己警醒,学长也提点很多很多."沉下去,然后一战成名"学长如是对我说,我很开心.其实这完全算不算是题解,只是我个人的一些小想法而已.而且到现在还有一题不会...让自己长点记性吧. 题目 A :聪明的田鼠 Time Limit: 1 Sec Memory Limit: 128 MB Description 田鼠MIUMIU来到了一片农田,农田可以看成是一个M*N个方格的矩

LeetCode-001题解

此题目摘自LeetCode001 Given an array of integers, find two numbers such that they add up to a specific target number. The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2.

leetcode题解: Next Permutation

最近还一直在刷leetcode,当然,更多时候只是将题解写在自己的电脑上,没有分享出来.偶尔想起来的时候,就写出来. public class Solution { public void nextPermutation(int[] nums) { if(nums==null||nums.length<=1) return; nextPermutationHelp( nums,0,nums.length-1); } public void nextPermutationHelp(int []nu

HDU 5014 Number Sequence(2014 ACM/ICPC Asia Regional Xi&#39;an Online) 题解

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5014 Number Sequence Problem Description There is a special number sequence which has n+1 integers. For each number in sequence, we have two rules: ● ai ∈ [0,n] ● ai ≠ aj( i ≠ j ) For sequence a and sequ

HDU 1045 Fire Net 二分图Bipartite题解

本题可以使用DFS直接爆搜出答案,不过这样类型的题目其实是个二分图的题解. 这个二分图,难不在Hungary算法,而是难在于建图.需要挺高的抽象思维的. 建图: 1 把同一行不被X分开的格子标同一个号码,被X分开的标下一个号码,这样做是为了缩点,不需要把所有的格子都分开标号,而且可以更方便建个更加小的图. 2 同理把同一列的格子标号 3 然后判断相同一个格子的行标号和列标号是有路径的,其他不在同一个格子的都是没有路径的. 4 这样就等于以行标号和列标号作为左右顶点,构建成一个二分图了 然后使用H